 package com.huimv.acquisition.controller;

 import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
 import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
 import com.baomidou.mybatisplus.core.metadata.IPage;
 import com.baomidou.mybatisplus.core.toolkit.Wrappers;
 import com.fasterxml.jackson.databind.ser.Serializers;
 import com.huimv.acquisition.entity.BasePigpenEntity;
 import com.huimv.acquisition.entity.CollectorRegisterEntity;
 import com.huimv.acquisition.entity.EartagDataEntity;
 import com.huimv.acquisition.entity.vo.EartagDataVo;
 import com.huimv.acquisition.entity.vo.EartagParamVo;
 import com.huimv.acquisition.mapper.BasePigpenDao;
 import com.huimv.acquisition.mapper.CollectorRegisterDao;
 import com.huimv.acquisition.mapper.EartagDataDao;
 import com.huimv.acquisition.result.R;
 import com.huimv.acquisition.service.BasePigpenService;
 import com.huimv.acquisition.socket.eartagrecive.util.StringUtilsWork;
 import com.huimv.acquisition.utils.PageUtils;
 import com.huimv.acquisition.utils.Query;
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;

 import java.util.Arrays;
 import java.util.HashMap;
 import java.util.List;
 import java.util.Map;


 /**
 * 栋舍表
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-07-30 16:02:09
 */
@RestController
@RequestMapping("management/basepigpen")

public class BasePigpenController {
    @Autowired
    private BasePigpenService basePigpenService;

     @Autowired
     private BasePigpenDao  basePigpenDao;

     @Autowired
     private CollectorRegisterDao collectorRegisterDao ;

     @Autowired
     private EartagDataDao  eartagDataDao;


    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = basePigpenService.queryPage(params);
        return R.ok().put("page", page);
    }



     /**
      * 展示牧场下面的栋的信息
      */
     @RequestMapping("/listFarmPigPen")
     public R listPigPen(@RequestBody Map<String, Object> params){
         Integer farmId = (Integer)params.get("farmId");
         LambdaQueryWrapper<BasePigpenEntity> wrapper = Wrappers.lambdaQuery();
         wrapper.eq(BasePigpenEntity::getFarmId,farmId).eq(BasePigpenEntity::getParentId,0);
         List<BasePigpenEntity> basePigpenEntities = basePigpenDao.selectList(wrapper);
         return R.ok().put("data", basePigpenEntities);
     }





     /**
      * 展示牧场下面的舍的信息
      */
     @RequestMapping("/listFarmUnit")
     public R listFarmUnit(@RequestBody Map<String, Object> params){
         Object penId1 = params.get("penId");
         System.out.println(penId1+"**********");

         Integer penId = (Integer)params.get("penId");
         System.out.println(penId+"*******");
         LambdaQueryWrapper<BasePigpenEntity> wrapper = Wrappers.lambdaQuery();
         wrapper.eq(BasePigpenEntity::getParentId,penId);
         List<BasePigpenEntity> basePigpenEntities = basePigpenDao.selectList(wrapper);
         return R.ok().put("data", basePigpenEntities);
     }







     /**
      * 展示单元下面的耳标实时信息
      */
     @RequestMapping("/listFarmUnitEartagData")
     public R listFarmUnitEartagData(@RequestBody Map<String, Object> params){

         String eartagNo = (String) params.get("eartagNo");//耳标号
         String unitNo = (String) params.get("unitNo");//最低日龄
         String deviceCode = (String) params.get("deviceCode");//采集器编码
         String penNo = (String) params.get("penNo");//采集器编码
         Integer pageNo = (Integer) params.get("pageNo");
         Integer pageSize = (Integer)  params.get("pageSize");
         Integer EarTempStatus = (Integer)  params.get("EarTempStatus");

         System.out.println("状态"+EarTempStatus);
         EartagParamVo  eartagParamVo = new EartagParamVo();

         eartagParamVo.setLimit(String.valueOf(pageSize));
         eartagParamVo.setPage(String.valueOf(pageNo));
         eartagParamVo.setEarTempStatus(EarTempStatus);

         //耳标号
         if (StringUtilsWork.isNotBlank(eartagNo)) {
             eartagParamVo.setEartagNo(eartagNo);
         }

         //单元号
         if (StringUtilsWork.isNotBlank(unitNo)) {
             eartagParamVo.setEartagNo(unitNo);
         }

         //采集器标号
         if (StringUtilsWork.isNotBlank(deviceCode)) {
             eartagParamVo.setEartagNo(deviceCode);
         }

         eartagParamVo.setPenNo(penNo);

         eartagParamVo.setUnitNo(unitNo);
         //分页需要Map类型   可以封装一下  现在不封装
         Map<String , Object>  pageMap  = new HashMap<>();
         pageMap.put("page",eartagParamVo.getPage());
         pageMap.put("limit",eartagParamVo.getLimit());
         IPage<EartagDataVo> page = eartagDataDao.pageIndex(new Query<EartagDataVo>().getPage(pageMap) ,eartagParamVo);

         return R.ok().put("data", page);
     }


     /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		BasePigpenEntity basePigpen = basePigpenService.getById(id);

        return R.ok().put("basePigpen", basePigpen);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody BasePigpenEntity basePigpen){
		basePigpenService.save(basePigpen);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody BasePigpenEntity basePigpen){
		basePigpenService.updateById(basePigpen);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){
		basePigpenService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }

}
