package com.huimv.eartag.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.common.token.TokenSign;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import com.huimv.eartag.entity.BaseFarmInfo;
import com.huimv.eartag.service.IBaseFarmInfoService;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author astupidcoder
 * @since 2022-01-07
 */
@RestController
@RequestMapping("/baseFarmInfo")
public class BaseFarmInfoController {
    @Autowired
    private IBaseFarmInfoService baseFarmInfoService;



    @PostMapping("/add")
    public Result saveFarmAndAccount(@RequestBody BaseFarmInfo baseFarmInfo, HttpServletRequest request){
        Integer userId = TokenSign.getMemberIdByJwtToken(request);

        baseFarmInfo.setCreateTime(new Date());
        baseFarmInfo.setCreateUser(userId);

        String farmName = baseFarmInfo.getFarmName();
        int count = baseFarmInfoService.count(new QueryWrapper<BaseFarmInfo>().eq("farm_name", farmName));
        if (count>0){
            return new Result(10001,"牧场已经存在",false);
        }
        return baseFarmInfoService.saveFarmAndAccount(baseFarmInfo);

    }

    @GetMapping("/getSellStauts")
    public Result getSellStauts(@Param("farmId")Integer farmId){
        BaseFarmInfo byId = baseFarmInfoService.getById(farmId);
        return new Result(ResultCode.SUCCESS,byId.getSellStatus());
    }


    @PostMapping("/update")
    public Result update(@RequestBody BaseFarmInfo baseFarmInfo){
        baseFarmInfoService.updateById(baseFarmInfo);
        return new Result(10000,"修改成功",true);
    }


    @GetMapping("/remove")
    public Result remove(@RequestParam(name = "ids") List<Integer> ids){

        return baseFarmInfoService.removeByIdsAndAccount(ids);
    }


    @PostMapping("/page")
    public Result page(@RequestBody Map map){
        return baseFarmInfoService.pageAll(map);

    }

    @GetMapping("/list")
    public Result list(HttpServletRequest request){
        Integer userId = TokenSign.getMemberIdByJwtToken(request);
        if (userId !=null &&  1== userId) {
            return new Result(ResultCode.SUCCESS,baseFarmInfoService.list());
        }
        String farmIds = TokenSign.getFarmIds(request);

        List<Integer> idList = Arrays.stream(farmIds.split(",")).map(Integer::parseInt).collect(Collectors.toList());
        return new Result(ResultCode.SUCCESS,baseFarmInfoService.listByIds(idList));


    }

    @GetMapping("/listByType")
    public Result list(@RequestParam(name = "type")Integer type){
        return new Result(ResultCode.SUCCESS,  baseFarmInfoService.list(new QueryWrapper<BaseFarmInfo>().eq("type",type)));
    }

    @GetMapping("/listAll")
    public Result list(){

        return new Result(ResultCode.SUCCESS,baseFarmInfoService.list());
    }

}
