package com.huimv.eartag.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.common.token.TokenSign;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import com.huimv.eartag.entity.BaseFarmInfo;
import com.huimv.eartag.entity.BasePigpen;
import com.huimv.eartag.entity.CollectorRegister;
import com.huimv.eartag.service.IBaseFarmInfoService;
import com.huimv.eartag.service.IBasePigpenService;
import com.huimv.eartag.service.ICollectorRegisterService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.*;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author astupidcoder
 * @since 2022-01-07
 */
@RestController
@RequestMapping("/basePigpen")
public class BasePigpenController {
    @Autowired
    private IBasePigpenService basePigpenService;

    @Autowired
    private ICollectorRegisterService collectorRegisterService;

    @Autowired
    private IBaseFarmInfoService baseFarmInfoService;

    @PostMapping("/add")
    public Result add(@RequestBody BasePigpen basePigpen, HttpServletRequest request){

        Integer userId = TokenSign.getMemberIdByJwtToken(request);
        Integer farmId = basePigpen.getFarmId();

        basePigpen.setCreatTime(new Date());
        basePigpen.setCreatUser(userId);
        basePigpen.setFarmCode(farmId+"");

        BaseFarmInfo byId = baseFarmInfoService.getById(farmId);
        basePigpen.setFarmName(byId.getFarmName());
        basePigpen.setTypeF(byId.getType());
        basePigpenService.save(basePigpen);

        return new Result(10000,"添加成功",true);
    }





    @PostMapping("/update")
    public Result update(@RequestBody BasePigpen basePigpen){

        basePigpenService.updateById(basePigpen);
        return new Result(10000,"修改成功",true);
    }


    @GetMapping("/remove")
    public Result remove(@RequestParam(name = "ids") List<Integer> ids){

        int sum = collectorRegisterService.count(new QueryWrapper<CollectorRegister>().in("pigpen_id", ids));
        if (sum > 0){
            return new Result(10001,"猪舍下有采集器，删除失败",false);
        }

        collectorRegisterService.removeByIds(ids);

        basePigpenService.removeByIds(ids);
        return new Result(10000,"删除成功",true);
    }

    
    
    

    @PostMapping("/page")
    public Result page(@RequestBody Map map){
        //嵌套牧场
        /*nnnnnnnnnnn*/
        return basePigpenService.pageAll(map);

    }

    @GetMapping("/list")
    public Result page(@RequestParam(name = "farmId") Integer farmId){
        List<BasePigpen> farmList = basePigpenService.list(new QueryWrapper<BasePigpen>().eq("farm_id", farmId).eq("type",1));
        for (BasePigpen basePigpen : farmList) {
            basePigpen.setChildren(basePigpenService.list(new QueryWrapper<BasePigpen>().eq("parent_id",basePigpen.getId())));
        }
        return new Result(ResultCode.SUCCESS,farmList);

    }


}
