package com.huimv.eartag.controller;


import com.huimv.common.utils.Result;
import com.huimv.eartag.entity.BizInspectionPhoto;
import com.huimv.eartag.service.IBizInspectionPhotoService;
import com.huimv.eartag.utils.UpImage;
import org.apache.ibatis.annotations.Arg;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author astupidcoder
 * @since 2022-03-03
 */
@RestController
@RequestMapping("/bizInspectionPhoto")
public class BizInspectionPhotoController {
    @Autowired
    private IBizInspectionPhotoService bizInspectionPhotoService;

    @PostMapping("/addInspection")
    public Result addInspection( HttpServletRequest request, @RequestParam(name = "files",required = false) MultipartFile[] files,
                                 @RequestParam(name ="farmId") String farmId,
                                 @RequestParam(name ="batchNo") String batchNo,
                                 @RequestParam(name = "inspecStatus") Integer inspecStatus,
                                 @RequestParam(name = "inspecRremark",required = false) String inspecRremark,
                                 @RequestParam(name = "inspecRealNum") Integer inspecRealNum){


        return bizInspectionPhotoService.addInspection(request,files,farmId,batchNo,inspecStatus,inspecRremark,inspecRealNum);

    }

    @PostMapping("/addBatch")
    public Result addBatch( HttpServletRequest request, @RequestParam(name = "files",required = false) MultipartFile[] files,
                            @RequestParam(name ="farmId") String farmId,
                            @RequestParam(name ="batchNo") String batchNo,
                            @RequestParam(name = "inspecStatus") Integer inspecStatus,
                            @RequestParam(name = "inspecRremark",required = false) String inspecRremark,
                            @RequestParam(name = "inspecRealNum") Integer inspecRealNum){


        return bizInspectionPhotoService.addBatch(request,files,farmId,batchNo,inspecStatus,inspecRremark,inspecRealNum);

    }

    @PostMapping("/listPic")
    public Result listPic(@RequestBody Map<String,String> map){

        return bizInspectionPhotoService.listPic(map);

    }

}
