package com.huimv.eartag.controller;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import com.huimv.eartag.entity.BaseFarmInfo;
import com.huimv.eartag.entity.BizSellPigApply;
import com.huimv.eartag.entity.BizSellPigApplyEartag;
import com.huimv.eartag.entity.EartagRegisterEntity;
import com.huimv.eartag.entity.dto.SellPig;
import com.huimv.eartag.service.EartagRegisterService;
import com.huimv.eartag.service.IBaseFarmInfoService;
import com.huimv.eartag.service.IBizSellPigApplyEartagService;
import com.huimv.eartag.service.IBizSellPigApplyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author astupidcoder
 * @since 2022-03-01
 */
@RestController
@RequestMapping("/bizSellPigApplyEartag")
public class BizSellPigApplyEartagController {

    @Autowired
    private IBizSellPigApplyService bizSellPigApplyService;


    //明细
    @Autowired
    private IBizSellPigApplyEartagService bizSellPigApplyEartagService;


    @Autowired
    private EartagRegisterService eartagRegisterService;

    @Autowired
    private IBaseFarmInfoService baseFarmInfo;

    @Transactional
    @PostMapping("/addSellPig")
    public Result addSellPig(@RequestBody SellPig sellPig){
        String[] eartagNos = sellPig.getEartagNos().split(",");

        if (sellPig.getRealEartagNum() < eartagNos.length){
            return new Result(10001,"手填耳标少于自动上传耳标，请检查",false);
        }
        BizSellPigApply bizSellPigApply = new BizSellPigApply();
        BeanUtil.copyProperties(sellPig,bizSellPigApply);

        String bacthNo = DateUtil.format(new Date(), "yyyyMMddHHmmssSSS");
        bizSellPigApply.setBatchNo(bacthNo);
        bizSellPigApply.setSellTime(new Date());
        bizSellPigApply.setAutoEartagNum(eartagNos.length);

        bizSellPigApplyService.save(bizSellPigApply);

        List list = new ArrayList();
        for (String eartagNo : eartagNos) {
            BizSellPigApplyEartag bizSellPigApplyEartag = new BizSellPigApplyEartag();
            bizSellPigApplyEartag.setBatchNo(bacthNo);
            bizSellPigApplyEartag.setEarmark(eartagNo);
            bizSellPigApplyEartag.setFarmId(sellPig.getFarmId());
            list.add(bizSellPigApplyEartag);
        }
        bizSellPigApplyEartagService.saveBatch(list);


        String inspecOrgId = sellPig.getInspecOrgId();
        String butcherOrgId = sellPig.getButcherOrgId();
        BaseFarmInfo byId = baseFarmInfo.getById(inspecOrgId);
        BaseFarmInfo byId1 = baseFarmInfo.getById(butcherOrgId);


        EartagRegisterEntity eartagRegisterEntity = new EartagRegisterEntity();
        eartagRegisterEntity.setSellStatus(2);
        eartagRegisterEntity.setInspecId(Integer.parseInt(inspecOrgId));
        eartagRegisterEntity.setInspecName(byId.getFarmName());
        eartagRegisterEntity.setButcherName(byId1.getFarmName());
        eartagRegisterEntity.setButcherId(Integer.parseInt(butcherOrgId));
        eartagRegisterEntity.setStage(11);
        eartagRegisterService.update(eartagRegisterEntity, new UpdateWrapper<EartagRegisterEntity>().in("eartag_no", Arrays.asList(eartagNos)));


        return new Result(10000,"申请成功",true);
    }

    @GetMapping("/listByBatch")
    public Result listByBatch(@RequestParam(name = "batchNo") String batchNo){

        return  new Result(ResultCode.SUCCESS,bizSellPigApplyEartagService.list(new QueryWrapper<BizSellPigApplyEartag>().eq("batch_no",batchNo)));
    }



}
