package com.huimv.eartag.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import com.huimv.eartag.entity.BizSellPigRemove;
import com.huimv.eartag.entity.EartagRegisterEntity;
import com.huimv.eartag.service.EartagRegisterService;
import com.huimv.eartag.service.IBizSellPigRemoveService;
import com.huimv.eartag.service.IEartagDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author astupidcoder
 * @since 2022-03-01
 */
@RestController
@RequestMapping("/bizSellPigRemove")
public class BizSellPigRemoveController {

    @Autowired
    private IBizSellPigRemoveService bizSellPigRemoveService;

    @Autowired
    private EartagRegisterService eartagRegisterService;

    @Transactional
    @PostMapping("/addRemovePig")
    public Result addRemovePig (@RequestBody BizSellPigRemove bizSellPigRemove){
        String earmark = bizSellPigRemove.getEarmark();
        String[] eartagno = earmark.split(",");
        String farmId = bizSellPigRemove.getFarmId();
        Date now = new Date();
        List list = new ArrayList();
        for (String s : eartagno) {
            BizSellPigRemove bizSellPigRemove1 = new BizSellPigRemove();
            bizSellPigRemove1.setEarmark(s);
            bizSellPigRemove1.setFarmId(farmId);
            bizSellPigRemove1.setRemoveTime(now);
            list.add(bizSellPigRemove1);
        }

        bizSellPigRemoveService.saveBatch(list);

        for (String s : eartagno) {
            EartagRegisterEntity eartagRegisterEntity = new EartagRegisterEntity();
            eartagRegisterEntity.setSellStatus(1);
            eartagRegisterService.update( eartagRegisterEntity,new UpdateWrapper<EartagRegisterEntity>().eq("eartag_no",s));
        }


        return new Result(10000,"排除成功",true);
    }

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    


    @Transactional
    @GetMapping("/removeRemovePig")
    public Result removeRemovePig (@RequestParam(name = "earmark")String earmark){

        String[] split = earmark.split(",");
        for (String eartagno : split) {
            bizSellPigRemoveService.remove(new QueryWrapper<BizSellPigRemove>().eq("earmark",eartagno));
            EartagRegisterEntity eartagRegisterEntity = new EartagRegisterEntity();
            eartagRegisterEntity.setSellStatus(0);
            eartagRegisterService.update( eartagRegisterEntity,new UpdateWrapper<EartagRegisterEntity>().eq("eartag_no",eartagno));
        }
        
        return new Result(10000,"操作成功",true);
    }

    @GetMapping("/list")
    public Result list (@RequestParam(name = "id")Integer farmId){

        return new Result(ResultCode.SUCCESS, bizSellPigRemoveService.list(new QueryWrapper<BizSellPigRemove>().eq("farm_id",farmId)));
    }
}
