package com.huimv.eartag.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import java.time.LocalDateTime;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author astupidcoder
 * @since 2022-03-01
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
public class BizSellPigApply extends Model {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 批次编号
     */
    private String batchNo;

    /**
     * 牧场id
     */
    private String farmId;

    /**
     * 卖猪时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date sellTime;

    /**
     * 车牌号
     */
    private String plateNumber;

    /**
     * 自动上传耳标数量
     */
    private Integer autoEartagNum;

    /**
     * 手填数量
     */
    private Integer realEartagNum;

    /**
     *记录状态  0:暂存 1：已提交 2：取消  3:已完成  4:检疫失败  5:屠宰失败
     */
    private Integer recordStatus;

    /**
     * 检疫部门id
     */
    private String inspecOrgId;

    /**
     * 屠宰机构id
     */
    private String butcherOrgId;

    /**
     * 最终状态 1:允许销售,2:禁止销售，政府人员操作
     */
    private Boolean applyStatus;

    /**
     * 创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date createTime;

    /**
     * 提交时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date applyTime;

    /**
     * 检验流程状态 0：未检验， 1:在场检验，2：屠宰检验
     */
    private Integer inspecFlowStatus;

    /**
     * 检疫类型  1：在场检验，2：屠宰场检验
     */
    private Integer inspecType;

    /**
     * 提交时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date inspecTime;


    /**
     * 提交时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date butcherInspecTime;


    /**
     * 提交时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date butcherTime;



    private Integer inspecRealNum;


    private Integer inspecAutoNum;


    private String inspecRemark;


    private Integer butcherRealNum;


    private Integer butcherAutoNum;


    private String butcherRemark;


}
