package com.huimv.eartag.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.time.LocalDateTime;

/**
 * <p>
 * 
 * </p>
 *
 * @author astupidcoder
 * @since 2022-01-13
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
public class EartagData extends Model {

    private static final long serialVersionUID = 1L;

    /**
     * 记录id(主键)
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 组织id
     */
    private Long orgId;

    /**
     * 采集器编码
     */
    private String deviceCode;

    /**
     * 耳标号
     */
    private String eartagNo;

    /**
     * 采集时间
     */
    private LocalDateTime time;

    /**
     * 耳根温度
     */
    private Double earTemp;

    /**
     * 运动量
     */
    private Integer exercise;

    /**
     * 栋舍
     */
    private String pigpen;

    /**
     * 单元ID
     */
    private Integer unitId;

    /**
     * 环境温度
     */
    private Double envTemp;

    /**
     * 电池电量
     */
    private Integer bat;

    /**
     * 信号强度
     */
    private Integer rssi;

    /**
     * 命令头
     */
    private String head;

    /**
     * 指令
     */
    private String command;

    /**
     * 版本号
     */
    private String version;

    /**
     * 耳标帧序号
     */
    private Integer frameSerialNo;

    /**
     * 重启次数
     */
    private Integer rebootTimes;

    /**
     * 预留字段
     */
    private String prepareField;

    /**
     * 校验码
     */
    private String chk;

    /**
     * 命令尾
     */
    private String tail;

    /**
     * 牧场编码
     */
    private String farmCode;

    /**
     * 阶段
     */
    private Integer stage;

    private Integer sportGap;

    private Integer sellStatus;


}
