/*
Copyright [2020] [https://www.xiaonuo.vip]

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：

1.请不要删除和修改根目录下的LICENSE文件。
2.请不要删除和修改Snowy源码头部的版权声明。
3.请保留源码和相关描述文件的项目出处，作者声明等。
4.分发源码时候，请注明软件出处 https://gitee.com/xiaonuobase/snowy
5.在修改包名，模块名称，项目代码等时，请注明软件出处 https://gitee.com/xiaonuobase/snowy
6.若您的项目无法满足以上几点，可申请商业授权，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.huimv.eartag.entity.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.sun.istack.NotNull;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;
import java.util.Date;

/**
* 设备管理参数类
 *
 * @author yinhao
 * @date 2021-08-19 09:43:52
*/
@Data
public class CollectorRegisterParam   {

    /**
     * 记录id(主键)
     */
    private Integer id;

    /**
     * 组织id
     */
    private Long orgId;

    /**
     * 组织名称
     */
    private String orgName;

    /**
     * 设备编码
     */
    private String deviceCode;

    /**
     * 盒子的芯片编码
     */

    private String registeCode;

    /**
     * 牧场编码
     */
    private String farmCode;

    /**
     * 牧场名称
     */
    private String farmName;

    /**
     * 动物种类
     */
    private Integer typeF;

    /**
     * 阶段
     */

    private Integer stage;

    /**
     * 猪舍id
     */

    private Integer pigpenId;

    /**
     * 栋舍名称
     */

    private String penName;

    /**
     * 单元id
     */

    private Integer unitId;

    /**
     * 单元名称
     */

    private String unitName;

    /**
     * 上传服务器地址
     */
    private String serverIp;

    /**
     * 端口
     */
    private Integer port;

    /**
     * 注册时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private Date registerTime;

    /**
     * 最后上传时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    private Date lastTime;

    /**
     * 0:正常,1:网络异常,2:采集异常,3:注销
     */
    private Integer canStatus;


    /**
     * 0:正常,1:网络异常,2:采集异常,3:注销
     */
    private Integer pageSize;


    private Integer pageNo;


    private Integer farmId;



}
