package com.huimv.eartag.utils;

import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.UUID;
import java.util.stream.Collectors;

public class UpImage {
    /**
     * @param file 单个文件
     * @param path 上传路径
     * @param request HttpServletRequest  用于获取协议 端口 服务器名称
     * @return java.lang.String   返回一个在线服务器访问地址
     * @author
     * @describe:   所有的上传都放在imgupload目录下
     * @date 2021/5/31 17:41
     */
//    public static String uploadImg(MultipartFile file, String path, HttpServletRequest request){
//        //上传路径
//        //  d:/imgupload/aaa/bbb/ccc;
//        //	/home/imgupload/aa/bb/cc
//        //获取配置静态资源上传文件夹 后面的路径
//        String paths = path.substring(path.indexOf("imgupload")+9);
//
//        //文件不为空时
//        if(!file.isEmpty()){
//            //拿到上传的文件名称
//            String originalFilename = file.getOriginalFilename();
//            //获取上传文件的后缀名
//            String substring = originalFilename.substring(originalFilename.lastIndexOf('.'));
//            //获得自定义文件名
//            String filename = UUID.randomUUID()+substring;
//            File f = new File(path);
//            if(!f.exists()){
//                //不存在就创建文件夹
//                f.mkdirs();
//            }
//            try {
//                file.transferTo(new File(path,filename));
//                //返回访问地址	image 就是配置的静态资源访问路径
//                String s = VisitSite.GetVisitSite(request)+"image"+paths+"/"+filename;
// //输出：http://localhost:8080/image/merchantimg/b6a27a5f-6a3c-4f0d-a9d2-7c05578204f5.jpg
//                return s;
//            } catch (IOException e) {
//                e.printStackTrace();
//            }
//        }
//        return null;
//    }

    /**
     * @param files  多个文件
	 * @param path  文件上传路径
	 * @param request
     * @return java.lang.String 返回在线服务器访问路径
     * @author
     * @describe:
     * @date 2021/6/10 13:49
     */
    public static String uploadImgs(MultipartFile[] files, String path, HttpServletRequest request){


        String paths = path.substring(path.indexOf("/opt/goldpig-huimv/img")+18);

        if(files.length>0){
//                System.out.println("进来了"+identity.length);
            //获取上传路径
            File file = new File(path);
            if(!file.exists()){
                //不存在就创建文件夹
                file.mkdirs();
            }
            List<String> list = new ArrayList<>();
            for (MultipartFile multipartFile : files) {
                if(!multipartFile.isEmpty()){
                    String originalFilename = multipartFile.getOriginalFilename();
                    //获取文件后缀名
                    String substring = originalFilename.substring(originalFilename.lastIndexOf('.'));
                    //获得自定义文件名
                    String filename = UUID.randomUUID()+substring;
                    try {
                        //开始上传
                        multipartFile.transferTo(new File(path,filename));
                        String s = "/image"+paths+"/"+filename;
                        list.add(s);
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }
            //把list转为字符串以,隔
            String str = list.stream().collect(Collectors.joining(","));
 //这样就可以直接通过路径访问了
//http://localhost:8080/image/commodityimg/f7079abc-a281-465e-889c-656e9e82ac63.png,http://localhost:8080/image/commodityimg/ac81a6ac-1e93-46d6-9482-f16f4938c0d2.jpg
            return str;
        }
        return null;
    }
}